import { NgZone } from '@angular/core';
import { ReplaySubject } from 'rxjs';
import { IPlayerApiScriptOptions, IPlayerOutputs, IPlayerSize } from '../models';
export declare function win(): Window;
export declare function YouTubeRef(): any;
export declare function YouTubePlayerRef(): any;
export declare const defaultSizes: {
    height: number;
    width: number;
};
export declare class YoutubePlayerService {
    private zone;
    api: ReplaySubject<YT.Player>;
    private ytApiLoaded;
    constructor(zone: NgZone);
    loadPlayerApi(options: IPlayerApiScriptOptions): void;
    setupPlayer(elementId: string, outputs: IPlayerOutputs, sizes: IPlayerSize, videoId: string | undefined, playerVars: YT.PlayerVars): void;
    play(player: YT.Player): void;
    pause(player: YT.Player): void;
    playVideo(media: any, player: YT.Player): void;
    isPlaying(player: YT.Player): boolean;
    createPlayer(elementId: string, outputs: IPlayerOutputs, sizes: IPlayerSize, videoId?: string, playerVars?: YT.PlayerVars): any;
    toggleFullScreen(player: YT.Player, isFullScreen: boolean | null | undefined): void;
    generateUniqueId(): string;
    private createApi;
}
